<?PHP
class func{

	public $UserIP = "Undefined"; # IP пользователя
	public $UserCode = "Undefined"; # Код от IP
	public $TableID = -1; # ID таблицы
	public $UserAgent = "Undefined"; // Браузер пользователя
	public $Userparse = "Undefined"; // Браузер пользователя

	/*======================================================================*\
	Function:	__construct
	Output:		Нет
	Descriiption: Выполняется при создании экземпляра класса
	\*======================================================================*/
	public function __construct(){
		$this->UserIP = $this->GetUserIp();
		$this->UserCode = $this->IpCode();
		$this->UserAgent = $this->UserAgent();
		$this->Userparse = $this->Userparse();
	}
	
	/*======================================================================*\
	Function:	__destruct
	Output:		Нет
	Descriiption: Уничтожение объекта
	\*======================================================================*/
	public function __destruct(){
	
	}
	/*======================================================================*\
	Function:	IpToLong
	Descriiption: Преобразует IP в целочисленное
	\*======================================================================*/
	public function IpToInt($ip){ 
		$ip = ip2long($ip); 
		($ip < 0) ? $ip+=4294967296 : true; 
		return $ip; 
	}
	/*======================================================================*\
	Function:	IpToLong
	Descriiption: Преобразует целочисленное в IP
	\*======================================================================*/
	public function IntToIP($int){ 
  		return long2ip($int);  
	}
	/*======================================================================*\
	Function:	GetUserIp
	Output:		UserIp
	Descriiption: Определяет IP пользователя
	\*======================================================================*/
	public function GetUserIp(){
	
		if($this->UserIP == "Undefined"){
			
			if(isset($_SERVER['HTTP_X_FORWARDED_FOR']) AND !empty($_SERVER['HTTP_X_FORWARDED_FOR']))
   			{
				
                            $client_ip = ( !empty($_SERVER['REMOTE_ADDR']) ) ? $_SERVER['REMOTE_ADDR'] : ( ( !empty($_ENV['REMOTE_ADDR']) ) ? $_ENV['REMOTE_ADDR'] : "unknown" );
                            $entries = preg_split('[, ]', $_SERVER['HTTP_X_FORWARDED_FOR']);

                            reset($entries);
				
				while (list(, $entry) = each($entries))
				{
				$entry = trim($entry);
					if ( preg_match("/^([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)/", $entry, $ip_list) )
				 	{
					
					$private_ip = array(
						  '/^0\./',
						  '/^127\.0\.0\.1/',
						  '/^192\.168\..*/',
						  '/^172\.((1[6-9])|(2[0-9])|(3[0-1]))\..*/',
						  '/^10\..*/');
		
						$found_ip = preg_replace($private_ip, $client_ip, $ip_list[1]);
		
						if ($client_ip != $found_ip)
						{
					   	$client_ip = $found_ip;
					   	break;
						}
						
					}
					
				}
			
			$this->UserIP = $client_ip;
			return $client_ip;
			
			}else return ( !empty($_SERVER['REMOTE_ADDR']) ) ? $_SERVER['REMOTE_ADDR'] : ( ( !empty($_ENV['REMOTE_ADDR']) ) ? $_ENV['REMOTE_ADDR'] : "unknown" );
		
		}else return $this->UserIP;
	}
	/*======================================================================*\
	Function:	IsLogin
	Output:		True / False
	Input:		Строка логина, Маска, Длина ("10, 25") && ("10") 
	Descriiption: Проверяет правильность ввода логина
	\*======================================================================*/
	public function IsLogin($login){
            return (is_array($login)) ? false : (preg_match("#^[a-zA-Z0-9]{4,10}$#", $login)) ? $login : false;
	}
	
	/*======================================================================*\
	Function:	IsPassword
	Output:		True / False
	Input:		Строка пароля, Маска, Длина ("10, 25") && ("10") 
	Descriiption: Проверяет правильность ввода пароля
	\*======================================================================*/
	public function IsPassword($password){
            return (is_array($password)) ? false : (preg_match("#^[a-zA-Z0-9]{4,20}$#", $password)) ? $password : false;
	
	}
	/*======================================================================*\
	Function:	IsMail
	Output:		True / False
	Input:		Email 
	Descriiption: Проверяет правильность ввода email адреса
	\*======================================================================*/
	public function IsMail($mail){
            if(is_array($mail) && empty($mail) && strlen($mail) > 255 && strpos($mail,'@') > 64) return false;
            return ( ! preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $mail)) ? false : strtolower($mail);	
	}
        /*======================================================================*\
	Function:	IsPin
	Output:		True / False
	Descriiption: Проверяет правильность ввода платежного парол
	\*======================================================================*/
	public function IsPin($pin){
            return (is_array($pin)) ? false : (preg_match("#^[0-9]{3}$#", $pin)) ? $pin : false;
	
	}
	/*======================================================================*\
	Function:	IpCode
	Output:		String, Example 255025502550255
	Input:		- 
	Descriiption: Возвращает IP с замененными знаками "." на "0"
	\*======================================================================*/
	public function IpCode(){
		$arr_mask = explode(".",$this->GetUserIp());
		return $arr_mask[0].".".$arr_mask[1].".".$arr_mask[2].".0";

	}
	/*======================================================================*\
	Function:	UserAgent
	Descriiption: Возвращает браузер пользователя
	\*======================================================================*/
	public function UserAgent(){
            if(empty($_SERVER['HTTP_USER_AGENT'])) {
                return array(
                    'name' => 'unrecognized',
                    'version' => 'unknown',
                    'platform' => 'unrecognized',
                    'userAgent' => ''
                );
            }
            return $this->TextClean($_SERVER['HTTP_USER_AGENT']);
	}
	
	/*======================================================================*\
	Function:	TextClean
	Descriiption: Очистка текста
	\*======================================================================*/
	public function TextClean($text){
            $array_find = array("`", "<", ">", "^", '"', "~", "\\");
            $array_replace = array("&#96;", "&lt;", "&gt;", "&circ;", "&quot;", "&tilde;", "");
            return str_replace($array_find, $array_replace, $text);
	}
	
	/*======================================================================*\
	Function:	md5Password
	Descriiption: Возвращает md5_пароля
	\*======================================================================*/
	public function md5Password($pass){
            $pass = strtolower($pass);
            return md5('PSWeb'.$_SERVER['HTTP_HOST'].'-'.$pass);	
	}
        /*======================================================================*\
	Function:	Userparse
	Descriiption: Возвращает браузер пользователя
	\*======================================================================*/
	public function Userparse(){
            if(isset($_SERVER["HTTP_REFERER"])){
                $hosturl=$_SERVER['HTTP_REFERER'];
                preg_match("/^((http:\/\/)|(https:\/\/))([a-zа-я0-9\-_\.]*)\/*.*$/i",$hosturl,$matches);
                $host = $matches[4];
            }else{
                $host = "";
            }
            return $host;
        }
        
        function CheckPayeer($purse){
		if( substr($purse,0,1) != "P" ) return false;
                if( !preg_match("#^[0-9]{7,}$#", substr($purse,1)) ) return false;	
                return $purse;
	}

        //Определение страны пользователя
        function GeoIpClient() {
            $ip = $this->GetUserIp();
            $xml=@simplexml_load_file('http://ipgeobase.ru:7020/geo?ip='.$ip);
            $country = ($xml->ip->country) ? $xml->ip->country : FALSE;
            if ($country){ 
                $_SESSION['country'] = $country;
            }else{
                $_SESSION['country'] = 'none';
            }
        }
        
        function ValidateInt($int){
            return filter_var($int, FILTER_VALIDATE_INT);
        }
        
        function ValidateFloat($float){
            return filter_var($float, FILTER_VALIDATE_FLOAT);
        }
        
        function validateDate($date, $format = 'Y-m-d H:i:s') {
            $check  = \DateTime::createFromFormat($format, $date);
            if ($date === false) {
                return false;
            }
            return true;
        }
        function GenPassword(){
            $chars='qazxswedcvfrtgbnhyujmkiolp1234567890';
            $max=10;
            $size=StrLen($chars)-1; 
            $password=null;
            while($max--){
                $password.=$chars[rand(0,$size)];
            }
            return $password;
        }
        function getLog($type,$TextError,$data=''){
            $fp = fopen('logs/log.txt', 'a');
            fwrite($fp, date('Y-m-d H:i:s',time()).' '.$type.': '.$TextError.'; DATA: '.$data . PHP_EOL);
            fclose($fp);
        }
}